﻿
#include "Funktionen.h"
#include "main.h"


void Init_AVR ( void )
{
	// IOs
	//////////////////////////////////////////////////////////////////////////
	// BLDC Controll Pins
	PORTD = 0;
	DDRD = 0xff;
	DDRD &= ~(1<<PD6);
	
	// LED
	PORTB &= ~(1<<PB2);
	DDRB |= (1<<PB2);
	
	// Button
	PORTB |= (1<<PB0);
	
	// PWM
	//////////////////////////////////////////////////////////////////////////
	DDRB |= (1<<PB1);
	TCCR1A |= (1<<COM1A1);				// non-invertig
	TCCR1A |= (1<<COM1B1);				// non-invertig
	TCCR1A |= (1<<WGM11);				// Fas-PWM ; TOP ICR1
	TCCR1B |= (1<<WGM12) | (1<<WGM13);  // Fas-PWM ; TOP ICR1
	ICR1 = 1999;						// Top = 2000 => 10kHz PWM;
	TCCR1B |= (1<<CS10);				// no Prescaling
	TIMSK1 |= (1<<TOIE1);				// Timeroverflowinterrupt
	OCR1A = STARTDUTY;					// Start Duty = 25;
	OCR1B = 1800;						// ADC Triggerdelay

	
	// ADC
	//////////////////////////////////////////////////////////////////////////
	ADCSRA |= (1<<ADEN) | (1<<ADATE) | (1<<ADPS0) | (1<<ADPS1) | (1<<ADPS2);	// Prescaler = 128
	ADCSRB |= (1<<ADTS0) | (1<<ADTS2);
	
	ADMUX = MUX_U;
	StartConversation();
	
	// Global Interrupt enable
	//////////////////////////////////////////////////////////////////////////
	sei();
}

// Same as RestartCommutation but other name, makes more sense
void NextCommutation ( void )
{
	switch ( CommutationVector ){
		case 1: L1_PWM_ENABLE(); L3_LOW_ENABLE();L2_FLOATING_ENABLE(); break;
		case 2: L2_PWM_ENABLE(); L3_LOW_ENABLE();L1_FLOATING_ENABLE(); break;
		case 3: L2_PWM_ENABLE(); L1_LOW_ENABLE();L3_FLOATING_ENABLE(); break;
		case 4: L3_PWM_ENABLE(); L1_LOW_ENABLE();L2_FLOATING_ENABLE(); break;
		case 5: L3_PWM_ENABLE(); L2_LOW_ENABLE();L1_FLOATING_ENABLE(); break;
		case 6: L1_PWM_ENABLE(); L2_LOW_ENABLE();L3_FLOATING_ENABLE(); break;
		default: break;
	}
	Values.ForceCommutate = FORCE_COMMUTATION_TIME;
}

// Same as NextCommutation but other name, makes more sense
void RestartCommutation ( void )
{	
	switch ( CommutationVector ){
		case 1: L1_PWM_ENABLE(); L3_LOW_ENABLE();L2_FLOATING_ENABLE(); break;
		case 2: L2_PWM_ENABLE(); L3_LOW_ENABLE();L1_FLOATING_ENABLE(); break;
		case 3: L2_PWM_ENABLE(); L1_LOW_ENABLE();L3_FLOATING_ENABLE(); break;
		case 4: L3_PWM_ENABLE(); L1_LOW_ENABLE();L2_FLOATING_ENABLE(); break;
		case 5: L3_PWM_ENABLE(); L2_LOW_ENABLE();L1_FLOATING_ENABLE(); break;
		case 6: L1_PWM_ENABLE(); L2_LOW_ENABLE();L3_FLOATING_ENABLE(); break;
		default: break;
	}
}







