﻿
#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>

#define MUX_U					0
#define MUX_I					1
#define MUX_FLUXTHRESHOLD		2
#define MUX_BEMF1				3
#define MUX_BEMF2				4
#define MUX_BEMF3				5

#define PWM_OVERFLOW			TIMER1_OVF_vect

#define StartConversation()		(ADCSRA |= (1<<ADSC))

#define DEBOUNCETIME			5000
#define OVERCURRENTTHRESHOLD	500
#define FORCE_COMMUTATION_TIME	5000
#define STARTDUTY				750

// PWM States
#define L1_FLOATING_ENABLE()	(PORTD &= ~(1<<PD2)); (PORTD |= ( (1<<PD4) | (1<<PD7) )) 
#define L2_FLOATING_ENABLE()	(PORTD &= ~(1<<PD4)); (PORTD |= ( (1<<PD2) | (1<<PD7) )) 
#define L3_FLOATING_ENABLE()	(PORTD &= ~(1<<PD7)); (PORTD |= ( (1<<PD2) | (1<<PD4) )) 
#define POWERSTAGE_OFF()		(PORTD &= ~((1<<PD2) | (1<<PD4) | (1<<PD7)) )

#define L1_PWM_ENABLE()			(DDRD &= ~(1<<PD0))
#define L2_PWM_ENABLE()			(DDRD &= ~(1<<PD3)) 
#define L3_PWM_ENABLE()			(DDRD &= ~(1<<PD5))

#define L1_LOW_ENABLE()			(PORTD &= ~(1<<PD0)); (DDRD |= (1<<PD0)) 
#define L2_LOW_ENABLE()			(PORTD &= ~(1<<PD3)); (DDRD |= (1<<PD3))  
#define L3_LOW_ENABLE()			(PORTD &= ~(1<<PD5)); (DDRD |= (1<<PD5)) 

struct Values_s{
	uint16_t Fluxintegral;
	uint16_t VoltageRaw;
	uint16_t CurrentRaw;
	uint16_t FluxThreshold;
	uint16_t Temp; 
	uint8_t State;
	uint16_t ForceCommutate;
	uint16_t RPMCount;
	uint16_t RPM;
};



extern volatile struct Values_s Values;
extern volatile uint8_t CommutationVector;


