
#include "uart.h"

#define BAUDRATE 19200ul
#define BAUD_REGISTER_VALUE  ((F_CPU+BAUDRATE*8)/(BAUDRATE*16)-1)
#define BAUD_REAL (F_CPU/(16*(BAUD_REGISTER_VALUE+1)))    	// Reale Baudrate 
#define BAUD_ERROR ((BAUD_REAL*1000)/BAUDRATE) 				// Fehler in Promille, 1000 = kein Fehler.
#if ((BAUD_ERROR<990) || (BAUD_ERROR>1010))
  #error Baudratenfhler! Abweichung zu gross! 
#endif 
#if (BAUD_REGISTER_VALUE>255)
  #error Fehler bei Baudratenberechnung! 
#endif


/******************************************************************************
	Routine fr die Serielle Ausgabe
*/
	int uart_putchar ( char c, FILE *stream )
{
	while (!(UCSR0A & (1<<UDRE0)));					// Warte solange bis Zeichen gesendet wurde
	UDR0 = c;										//Ausgabe des Zeichens
	return (0);
}


/******************************************************************************
	Initialisert die serielle Schnittstelle
 	- Baud Rate 9600
*/	
	void USART_Init( void )
{
	// IO
	DDRD |=  (1<<PD1);
	
	// Baud Rate 
	UBRR0L = BAUD_REGISTER_VALUE;												
	UCSR0B = (1<<TXEN0); 
	fdevopen ( uart_putchar, NULL );	
}





